// ========================= Atmega128 ÷ LCD ׽Ʈ α׷ ===============
//  CPU : ATmega128-16M - 320*240 2.4" ÷ LCD
//     ¥ : 2008-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : AvrStudio 
//      : serial 19200,N,8,1
// ----------------------------------------------------------------------------
// ⺻ 
#define	__STDIO_FDEVOPEN_COMPAT_12

// ⺻ 
// === AVR includes ===
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
//#include <float.h>
//#include <math.h>

#include "avr/io.h"
#include "avr/interrupt.h"
#include "avr/delay.h"
#include "avr/pgmspace.h"

//  
#include "cpusetup.inc"							// cpu  ͷƮ  ƾ
#include "tftlcd.inc"							// ׷ LCD
#include "touch.inc"							// ġ 

// Լ 
void main_menu_disp(void);						//  ޴ ǥ

//  

// ===============================  α׷ ==============================
// [μ]: void
// ---------------------------------------------------------------------------
int main(void)
{
unsigned char image[50];
unsigned datau;
int i;

	cpu_setup();							// cpu ʱȭ
	TSC2003_Setup();						// I2c ʱȭ TSC2003ʱȭ
	Clcd_Init();							// LCD ʱȭ
	RGB_Disp();							// RGB  ǥ
// ڿ ǥ	
	Setcolor(_YELLOW);						//  
	Setbkcolor(_BLUE);						//  
	Putsxyt(12,9,"â ");					// ڿ ǥ
	Setcolor(_WHITE);						//  
	Setbkcolor(_BLUE);						//  
	Putsxyt(5,10,"www.cpuplaza.com");
	Setcolor(_WHITE);						//  
	Setbkcolor(_BLACK);						//  
	
	main_menu_disp();						//  ޴ ǥ
	while(1){
		if(com1_rx_eflg){					// COM1  ˻
			if(com1_rx_data == '0') main_menu_disp();	//  ޴ ǥ
			else if(com1_rx_data == '1') Clrscr();		// ȭ 
			else if(com1_rx_data == '2') Cleardevice();	// ȭ 
			else if(com1_rx_data == '3') Putpixel(10,10,_WHITE);// ȼ ǥ
			else if(com1_rx_data == '4') Putpixelb(0,1,0xff,_WHITE);// Ʈ  ǥ()
			else if(com1_rx_data == '5'){			// ̹ ǥ
				for(i = 0; i < 32; i++) image[i] = 0xaa;// 16bit * 16bit size
				Setcolor(_WHITE);			//  
				Setbkcolor(_BLACK);			//  
				Gotoxy(0,0);				// Ŀ ġ (0,0)
				PutImage(image,16,16);			// image ǥ
			}
			else if(com1_rx_data == '6') Putch('1');	// 1 ǥ
			else if(com1_rx_data == '7') Putchxy(16,2,'2');	// ׷ ǥ 1 ǥ
			else if(com1_rx_data == '8') Putchxyt(8,3,'3');	// ؽƮ ǥ 1 ǥ
			else if(com1_rx_data == '9') Puts("");	// ڿ ǥ
			else if(com1_rx_data == 'a') Putsxy(10,3,"׽Ʈ");// ׷ ǥ ڿ ǥ
			else if(com1_rx_data == 'b') Putsxyt(4,2,"׽Ʈ");// ؽƮ ǥ ڿ ǥ
			else if(com1_rx_data == 'c'){			//  پϰ ׸
				Line(0,0,200,0);			// 簢 ڽ
				Line(200,0,200,220);
				Line(200,220,0,220);
				Line(0,0,0,220);

				Line(0,110,200,110);			// +
				Line(100,0,100,220);

				Line(0,0,200,220);			// 밢
				Line(0,220,200,0);
			}
			else if(com1_rx_data == 'd') Rectangle(10,50,230,180);// 簢ڽ ׸
			else if(com1_rx_data == 'e'){			// ä ڽ ׸
				Setcolor(_RED);				//  
				Rectanglefill(50,50,190,150);		// 簢ڽ ä - RED
				timer0_cnt = 0;	while(timer0_cnt < 100);// 1 delay
				Setcolor(_WHITE);			//  
				Rectanglefill(50,50,190,150);		// 簢ڽ ä - WHITE
				timer0_cnt = 0;	while(timer0_cnt < 100);// 1 delay
				Setcolor(_BLUE);			//  
				Rectanglefill(50,50,190,150);		// 簢ڽ ä - BLUE
				timer0_cnt = 0;	while(timer0_cnt < 100);// 1 delay
				Setcolor(_YELLOW);			//  
				Rectanglefill(50,50,190,150);		// 簢ڽ ä - YELLOW
				timer0_cnt = 0;	while(timer0_cnt < 100);// 1 delay
				Setcolor(_BLACK);			//  
				Rectanglefill(50,50,190,150);		// 簢ڽ ä - BLACK
				Setcolor(_WHITE);			//  
			}
			else if(com1_rx_data == 'f') Circle(100,100,50);	//  ׸
			else if(com1_rx_data == 'g') Ellipse(100,100,50,20);// Ÿ ׸
			else if(com1_rx_data == 'h') RGB_Disp();	// RGB  ǥ
			else if(com1_rx_data == 'i'){			// ü ȭ  ȼ б
				if(_screen_mode == _SCREEN_COLUMN_SET) ScreenSet(_SCREEN_COLUMN_SET,0,0,_SCREEN_COLUMN_X,_SCREEN_COLUMN_Y);// ǥȭ  
				else ScreenSet(_SCREEN_ROW_SET,0,0,_SCREEN_ROW_X,_SCREEN_ROW_Y);// ǥȭ  
				
				datau = CLCD_GRAM_dread();		// ȼ 
				printf("pixel data : %04x\n",datau);				
			}
			else if(com1_rx_data == 'j'){
				printf("%s","SCREEN COLUMN MODE SET\n");
				ScreenSet(_SCREEN_COLUMN_SET,0,0,_SCREEN_COLUMN_X,_SCREEN_COLUMN_Y);// ǥȭ  
			}
			else if(com1_rx_data == 'k'){
				printf("%s","SCREEN ROW MODE SET\n");
				ScreenSet(_SCREEN_ROW_SET,0,0,_SCREEN_ROW_X,_SCREEN_ROW_Y);// ǥȭ  
			}
			else if(com1_rx_data == 'l'){
				printf("%s","Color :: WHITE\n");
				Setcolor(_WHITE);			//   WHITE
			}
			else if(com1_rx_data == 'm'){
				printf("%s","Color :: BLACK\n");
				Setcolor(_BLACK);			//   BLACK
			}
			else if(com1_rx_data == 'n'){
				printf("%s","Color :: RED\n");
				Setcolor(_RED);				//   RED
			}
			else if(com1_rx_data == 'o'){
				printf("%s","Color :: BLUE\n");
				Setcolor(_BLUE);			//   BLUE
			}
			else if(com1_rx_data == 'p'){
				printf("%s","Background Color :: BLUE\n");
				Setbkcolor(_BLUE);			//   BLUE
			}
			else if(com1_rx_data == 'q'){
				printf("%s","Background Color :: BLACK\n");
				Setbkcolor(_BLACK);			//   BLUE
			}
			else putchar(com1_rx_data);
			com1_rx_eflg = 0;
		}
		if(Touch_Data(2)){					// ġ  ˻ 20ms
			printf("touch > (x)%d : (y)%d\r\n",Touch_X,Touch_Y);
		}
	}
	return 0;
}

// ==================================  ޴ ǥ =========================
// [μ] void
// ---------------------------------------------------------------------------
void main_menu_disp(void)
{
	printf("%s","======== TFT LCD Test Main =========\n");
	printf("%s","- 0 : Main Menu Disp               -\n");
	printf("%s","- 1 : Clrscr     2 : Cleardevice   -\n");
	printf("%s","- 3 : Putpixel   4 : Putpixelb     -\n");
	printf("%s","- 5 : Putimage   6 : Putch         -\n");
	printf("%s","- 7 : Putchxy    8 : Putchxyt      -\n");
	printf("%s","- 9 : Puts       a : Putsxy        -\n");
	printf("%s","- b : Putsxyt    c : Line          -\n");
	printf("%s","- d : Rectangle  e : Rectanglefill -\n");
	printf("%s","- f : Circle     g : Ellipse       -\n");
	printf("%s","- h : RGB Data Display             -\n");
	printf("%s","- i : GRAM Data read               -\n");
	printf("%s","- j : SetScreen(COLUMN)            -\n");
	printf("%s","- k : SetScreen(ROW)               -\n");
	printf("%s","- l : Setcolor(_WHITE)             -\n");
	printf("%s","- m : Setcolor(_BLACK)             -\n");
	printf("%s","- n : Setcolor(_RED)               -\n");
	printf("%s","- o : Setcolor(_BLUE)              -\n");
	printf("%s","- p : Setbkcolor(_BLUE)            -\n");
	printf("%s","- q : Setbkcolor(_BLACK)           -\n");
	printf("%s","- touch screen press : x,y disp    -\n");
	printf("%s","------------------------------------\n");
}
