// ========================= Atmega128 ÷ LCD ׽Ʈ α׷ ===============
//  CPU : ATmega128-16M - 320*240 2.4" ÷ LCD
//     ¥ : 2008-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : CVAVR 
//      : serial 19200,N,8,1
// ----------------------------------------------------------------------------
// ⺻ 
#include <mega128.h>							// CPU  

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <float.h>
#include <math.h>
#include <string.h>
#include <delay.h>

//  
#include "cpusetup.inc"							// cpu  ͷƮ  ƾ
#include "tftlcd.inc"							// ׷ LCD
#include "touch.inc"							// ġ 

// Լ 
void main_menu_disp(void);						//  ޴ ǥ

//  

// ===============================  α׷ ==============================
// [μ]: void
// ---------------------------------------------------------------------------
int main(void)
{
char buf[50];
unsigned char image[50];
unsigned datau;
int i;

	cpu_setup();							// cpu ʱȭ
	TSC2003_Setup();						// I2c ʱȭ TSC2003ʱȭ
	Clcd_Init();							// LCD ʱȭ
	RGB_Disp();							// RGB  ǥ
// ڿ ǥ	
	Setcolor(_YELLOW);						//  
	Setbkcolor(_BLUE);						//  
	Putsxyt_f(12,9,"â ");					// ڿ ǥ
	Setcolor(_WHITE);						//  
	Setbkcolor(_BLUE);						//  
	Putsxyt_f(5,10,"www.cpuplaza.com");
	Setcolor(_WHITE);						//  
	Setbkcolor(_BLACK);						//  

	main_menu_disp();						//  ޴ ǥ
	while(1){
		if(com1_rx_eflg){					// COM1  ˻
			if(com1_rx_data == '0') main_menu_disp();	//  ޴ ǥ
			else if(com1_rx_data == '1') Clrscr();		// ȭ 
			else if(com1_rx_data == '2') Cleardevice();	// ȭ 
			else if(com1_rx_data == '3') Putpixel(10,10,_WHITE);// ȼ ǥ
			else if(com1_rx_data == '4') Putpixelb(0,1,0xff,_WHITE);// Ʈ  ǥ()
			else if(com1_rx_data == '5'){			// ̹ ǥ
				for(i = 0; i < 32; i++) image[i] = 0xaa;// 16bit * 16bit size
				Setcolor(_WHITE);			//  
				Setbkcolor(_BLACK);			//  
				Gotoxy(0,0);				// Ŀ ġ (0,0)
				PutImage(image,16,16);			// image ǥ
			}
			else if(com1_rx_data == '6') Putch('1');	// 1 ǥ
			else if(com1_rx_data == '7') Putchxy(16,2,'2');	// ׷ ǥ 1 ǥ
			else if(com1_rx_data == '8') Putchxyt(8,3,'3');	// ؽƮ ǥ 1 ǥ
			else if(com1_rx_data == '9'){
				sprintf(buf,"");			// ѱ ڿ
				Puts(buf);				// ڿ ǥ
				Puts_f("");				// CODE ڿ ǥ
			}
			else if(com1_rx_data == 'a'){
				sprintf(buf,"׽Ʈ1");
				Putsxy(10,3,buf);			// ׷ ǥ ڿ ǥ
				Putsxy_f(10,27,"׽Ʈ1");		// ׷ ǥ CODE ڿ ǥ
			}
			else if(com1_rx_data == 'b'){
				sprintf(buf,"׽Ʈ2");
				Putsxyt(4,2,buf);			// ؽƮ ǥ ڿ ǥ
				Putsxyt_f(4,3,"׽Ʈ2");		// ؽƮ ǥ ڿ ǥ
			}
			else if(com1_rx_data == 'c'){			//  پϰ ׸
				Line(0,0,200,0);			// 簢 ڽ
				Line(200,0,200,220);
				Line(200,220,0,220);
				Line(0,0,0,220);

				Line(0,110,200,110);			// +
				Line(100,0,100,220);

				Line(0,0,200,220);			// 밢
				Line(0,220,200,0);
			}
			else if(com1_rx_data == 'd') Rectangle(10,50,230,180);// 簢ڽ ׸
			else if(com1_rx_data == 'e'){			// ä ڽ ׸
				Setcolor(_RED);				//  
				Rectanglefill(50,50,190,150);		// 簢ڽ ä - RED
				timer0_cnt = 0;	while(timer0_cnt < 100);// 1 delay
				Setcolor(_WHITE);			//  
				Rectanglefill(50,50,190,150);		// 簢ڽ ä - WHITE
				timer0_cnt = 0;	while(timer0_cnt < 100);// 1 delay
				Setcolor(_BLUE);			//  
				Rectanglefill(50,50,190,150);		// 簢ڽ ä - BLUE
				timer0_cnt = 0;	while(timer0_cnt < 100);// 1 delay
				Setcolor(_YELLOW);			//  
				Rectanglefill(50,50,190,150);		// 簢ڽ ä - YELLOW
				timer0_cnt = 0;	while(timer0_cnt < 100);// 1 delay
				Setcolor(_BLACK);			//  
				Rectanglefill(50,50,190,150);		// 簢ڽ ä - BLACK
				Setcolor(_WHITE);			//  
			}
			else if(com1_rx_data == 'f') Circle(100,100,50);	//  ׸
			else if(com1_rx_data == 'g') Ellipse(100,100,50,20);// Ÿ ׸
			else if(com1_rx_data == 'h') RGB_Disp();	// RGB  ǥ
			else if(com1_rx_data == 'i'){			// ü ȭ  ȼ б
				if(_screen_mode == _SCREEN_COLUMN_SET) ScreenSet(_SCREEN_COLUMN_SET,0,0,_SCREEN_COLUMN_X,_SCREEN_COLUMN_Y);// ǥȭ  
				else ScreenSet(_SCREEN_ROW_SET,0,0,_SCREEN_ROW_X,_SCREEN_ROW_Y);// ǥȭ  
				
				datau = CLCD_GRAM_dread();		// ȼ 
				printf("pixel data : %04x\r\n",datau);				
			}
			else if(com1_rx_data == 'j'){
				printf("SCREEN COLUMN MODE SET\r\n");
				ScreenSet(_SCREEN_COLUMN_SET,0,0,_SCREEN_COLUMN_X,_SCREEN_COLUMN_Y);// ǥȭ  
			}
			else if(com1_rx_data == 'k'){
				printf("SCREEN ROW MODE SET\r\n");
				ScreenSet(_SCREEN_ROW_SET,0,0,_SCREEN_ROW_X,_SCREEN_ROW_Y);// ǥȭ  
			}
			else if(com1_rx_data == 'l'){
				printf("Color :: WHITE\r\n");
				Setcolor(_WHITE);			//   WHITE
			}
			else if(com1_rx_data == 'm'){
				printf("Color :: BLACK\r\n");
				Setcolor(_BLACK);			//   BLACK
			}
			else if(com1_rx_data == 'n'){
				printf("Color :: RED\r\n");
				Setcolor(_RED);				//   RED
			}
			else if(com1_rx_data == 'o'){
				printf("Color :: BLUE\r\n");
				Setcolor(_BLUE);			//   BLUE
			}
			else if(com1_rx_data == 'p'){
				printf("Background Color :: BLUE\r\n");
				Setbkcolor(_BLUE);			//   BLUE
			}
			else if(com1_rx_data == 'q'){
				printf("Background Color :: BLACK\r\n");
				Setbkcolor(_BLACK);			//   BLUE
			}
			else putchar(com1_rx_data);
			com1_rx_eflg = 0;
		}
		if(Touch_Data(2)){					// ġ  ˻ 20ms
			printf("touch > (x)%d : (y)%d\r\n",Touch_X,Touch_Y);
		}
	}
	return 0;
}

// ==================================  ޴ ǥ =========================
// [μ] void
// ---------------------------------------------------------------------------
void main_menu_disp(void)
{
	printf("======== TFT LCD Test Main =========\r\n");
	printf("- 0 : Main Menu Disp               -\r\n");
	printf("- 1 : Clrscr     2 : Cleardevice   -\r\n");
	printf("- 3 : Putpixel   4 : Putpixelb     -\r\n");
	printf("- 5 : Putimage   6 : Putch         -\r\n");
	printf("- 7 : Putchxy    8 : Putchxyt      -\r\n");
	printf("- 9 : Puts       a : Putsxy        -\r\n");
	printf("- b : Putsxyt    c : Line          -\r\n");
	printf("- d : Rectangle  e : Rectanglefill -\r\n");
	printf("- f : Circle     g : Ellipse       -\r\n");
	printf("- h : RGB Data Display             -\r\n");
	printf("- i : GRAM Data read               -\r\n");
	printf("- j : SetScreen(COLUMN)            -\r\n");
	printf("- k : SetScreen(ROW)               -\r\n");
	printf("- l : Setcolor(_WHITE)             -\r\n");
	printf("- m : Setcolor(_BLACK)             -\r\n");
	printf("- n : Setcolor(_RED)               -\r\n");
	printf("- o : Setcolor(_BLUE)              -\r\n");
	printf("- p : Setbkcolor(_BLUE)            -\r\n");
	printf("- q : Setbkcolor(_BLACK)           -\r\n");
	printf("- touch screen press : x,y disp    -\r\n");
	printf("------------------------------------\r\n");
}
